- NAME
- SYNOPSIS
- DESCRIPTION
- USAGE
- SEE ALSO

# NAME

HTML::Mason::MethodMaker - Used to create simple get & get/set methods in other classes

# SYNOPSIS

     use HTML::Mason::MethodMaker
         ( read_only => 'foo',
           read_write => [
                          [ bar => { type => SCALAR } ],
                          [ baz => { isa => 'HTML::Mason::Baz' } ],
                          'quux', # no validation
                         ],
           read_write_contained => { other_object =>
                                     [
                                      [ 'thing1' => { isa => 'Thing1' } ],
                                      'thing2', # no validation
                                     ]
                                   },
         );

# DESCRIPTION

This automates the creation of simple accessor methods.

# USAGE

This module creates methods when it is `use`'d by another module. There are three types of methods: 'read_only', 'read_write', 'read_write_contained'.

Attributes specified as 'read_only' get an accessor that only returns the value of the attribute. Presumably, these attributes are set via more complicated methods in the class or as a side effect of one of its methods.

Attributes specified as 'read_write' will take a single optional parameter. If given, this parameter will become the new value of the attribute. This value is then returned from the method. If no parameter is given, then the current value is returned.

If you want the accessor to use `Params::Validate` to validate any values passed to the accessor (and you _do_), then the the accessor specification should be an array reference containing two elements. The first element is the accessor name and the second is the validation spec.

The 'read_write_contained' parameter is used to create accessor for delayed contained objects. A delayed contained object is one that is not created in the containing object's accessor, but rather at some point after the containing object is constructed. For example, the Interpreter object creates Request objects after the Interpreter itself has been created.

The value of the 'read_write_contained' parameter should be a hash reference. The keys are the internal name of the contained object, such as ``request'' or ``compiler''. The values for the keys are the same as the parameters given for 'read_write' accessors.

# SEE ALSO

HTML::Mason